using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.Data.OracleClient ;

namespace SampleWebService
{
	public class DataAccessWebService : System.Web.Services.WebService
	{
		private System.Data.OracleClient.OracleConnection oraConnection ;

		public DataAccessWebService()
		{
			InitializeComponent();
			InitializeThis() ;
		}

		private void InitializeThis()
		{
			System.Text.StringBuilder conStr ;
			DataSet configSet ;
			DataTable paramTbl ;
			
			configSet = new DataSet() ;
			// T[oconfig.xmluĂ
			configSet.ReadXml( Server.MapPath( null ) + "\\config.xml" ) ;

			conStr = new System.Text.StringBuilder() ;
			paramTbl = configSet.Tables[ "ConnectionString" ] ;

			if ( paramTbl != null )
			{
				for ( int rowCnt = 0 ; rowCnt < paramTbl.Rows.Count ; rowCnt++ )
				{
					conStr.Append( paramTbl.Rows[ rowCnt ][ "key" ].ToString() ) ;
					conStr.Append( '=' ) ;
					conStr.Append( paramTbl.Rows[ rowCnt ][ "value" ].ToString() ) ;
					conStr.Append( ';' ) ;
				}
			}

			this.oraConnection = new OracleConnection( conStr.ToString() ) ;
		}

		#region R|[lg fUCiŐꂽR[h 
		
		//Web T[rX fUCiŕKvłB
		private IContainer components = null;
				
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		[ WebMethod ]
		public DataSet Request( string id )
		{
			DataSet returnValue ;
			OracleDataAdapter oraAdapter ;
			string sql ;

			returnValue = new DataSet() ;
			sql = "select ,Z,l from Z^ where id=\'" + id + "\'" ;

			oraAdapter = new OracleDataAdapter( sql , this.oraConnection ) ;
			oraAdapter.Fill( returnValue ) ;

			return returnValue ;
		}

		[ WebMethod ]
		public bool Insert( string name , string address , string memo )
		{
			bool returnValue ;
			OracleCommand oraCommand ;
			string sql ;

			sql = "insert into Z^ (ID,,Z,l) values(IDJE^.nextval,:,:Z,:l)" ;
			oraCommand = new OracleCommand( sql.ToString() , this.oraConnection ) ;

			oraCommand.Parameters.Add( "" , OracleType.VarChar , 32 ).Value = name ;
			oraCommand.Parameters.Add( "Z" , OracleType.VarChar , 128 ).Value = address ;
			oraCommand.Parameters.Add( "l" , OracleType.VarChar , 1024 ).Value = memo ;

			oraConnection.Open() ;
			try
			{
				oraCommand.Transaction = this.oraConnection.BeginTransaction() ;

				if ( oraCommand.ExecuteNonQuery() == 1 )
				{
					oraCommand.Transaction.Commit() ;
					returnValue = true ;
				}
				else
				{
					oraCommand.Transaction.Rollback() ;
					returnValue = false ;
				}
			}
			catch ( Exception ex )
			{
				returnValue = false ;
			}
			finally
			{
				oraConnection.Close() ;
			}
			return returnValue ;
		}

		[ WebMethod ]
		public int Update( string id , string name , string address , string memo )
		{
			int returnValue ;
			OracleCommand oraCommand ;
			string sql ;

			sql = "update Z^ set =:,Z=:Z,l=:l where ID=:ID" ;
			oraCommand = new OracleCommand( sql.ToString() , this.oraConnection ) ;

			oraCommand.Parameters.Add( "ID" , OracleType.Number ).Value = id ;
			oraCommand.Parameters.Add( "" , OracleType.VarChar , 32 ).Value = name ;
			oraCommand.Parameters.Add( "Z" , OracleType.VarChar , 128 ).Value = address ;
			oraCommand.Parameters.Add( "l" , OracleType.VarChar , 1024 ).Value = memo ;

			oraConnection.Open() ;
			try
			{
				oraCommand.Transaction = this.oraConnection.BeginTransaction() ;

				if ( ( returnValue = oraCommand.ExecuteNonQuery() ) == 1 )
				{
					oraCommand.Transaction.Commit() ;
				}
				else
				{
					oraCommand.Transaction.Rollback() ;
				}
			}
			catch ( Exception ex )
			{
				returnValue = -1 ;
			}
			finally
			{
				oraConnection.Close() ;
			}
			return returnValue ;
		}
	}
}
